#include <LCDWIKI_GUI.h> //Core graphics library
#include <LCDWIKI_KBV.h> //Hardware-specific library
#include <AM2302-Sensor.h>
#include <AM2302-Sensor.h>

#define SENSOR_PIN 8
int lightSensorPin = A0; // Analog pin
int lightValue;
float sunlight;
AM2302::AM2302_Sensor am2302{SENSOR_PIN};
LCDWIKI_KBV my_lcd(ILI9486,40,38,39,-1,41); //model,cs,cd,wr,rd,reset

void show_end()
{
    my_lcd.Fill_Screen(0, 255, 255);
    my_lcd.Set_Draw_color(255, 0, 0);
    my_lcd.Set_Text_colour(0, 0, 0);   
    my_lcd.Set_Text_Size(3);
    my_lcd.Set_Text_Mode(5);
    my_lcd.Print_String("Plant Health Station!", CENTER, my_lcd.Get_Display_Height()-250);
    my_lcd.Print_String("Receiving: " + String(sunlight) + "% sunlight", CENTER, my_lcd.Get_Display_Height()-200);
    my_lcd.Print_String("Temperature: " + String(am2302.get_Temperature()) + String(char(0xF6)) + "C", CENTER, my_lcd.Get_Display_Height() - 150);
    my_lcd.Print_String("Humidity: " + String(am2302.get_Humidity()) + "%", CENTER, my_lcd.Get_Display_Height()-100);
    delay(1000);   
}

void setup() 
{
  my_lcd.Init_LCD();
  my_lcd.Fill_Screen(0x0);  
  my_lcd.Set_Rotation(1);  
  Serial.begin(115200);

   // set pin and check for sensor
   if (am2302.begin()) {
      // this delay is needed to receive valid data,
      // when the loop directly read again
      delay(1000);
   }
   else {
      while (true) {
      Serial.println("Error: sensor check. => Please check sensor connection!");
      delay(10000);
      }
   }
}

void loop() 
{
    my_lcd.Fill_Screen(0x0); 
    show_end();
    
    // put your main code here, to run repeatedly:
   auto status = am2302.read();

   lightValue = abs(analogRead(lightSensorPin)-1023);  // 0 (dark) to 1023 (bright)
   Serial.print("Light Level: ");
   Serial.println(lightValue);

   sunlight = (lightValue/1023.0)*100.0;
   Serial.print("Sunlight: ");
   Serial.println(sunlight);

   Serial.print("Temperature: ");
   Serial.println(am2302.get_Temperature());

   Serial.print("Humidity:    ");
   Serial.println(am2302.get_Humidity());

   delay(1000);    
}